/**
 * Topological Sort
 *
 * Complexity (Time): O(V + E)
 * Complexity (Space): O(V + E)
 */

stack<int> S;
vector<int> graph[MAX];

int cont[MAX];

// Fill stack and check for cycles
bool dfs(int x) {
  cont[x] = 1;

  for (auto i : graph[x]) {
    if (cont[i] == 1)
      return true;
    if (!cont[i] && dfs(i))
      return true;
  }

  cont[x] = 2;
  S.push(x);

  return false;
}


// Returns whether graph contains cycle or not, and fills tsort vector with
// topological sort of the graph
bool topological_sort(int n, vector<int> &tsort) {
  mset(cont, 0);
  
  bool cycle = false;
  for (int i = 0; i < n; ++i)
    if (!cont[i])
      cycle |= dfs(i);

  if (cycle)
    return true;

  while (!S.empty()) {
    tsort.pb(S.top());
    S.pop();
  }

  return false;
}
