/**
 * Kadane
 *
 * Complexity (Time): O(n + m)
 * Complexity (Space): O(n + m)
 */

int v[MAX];

int kadane() {

  // Maximum so far (msf), Maximum ending here (meh).
  int msf = -0x3f3f3f3f, meh = 0;
  int start = 0, end = 0, s = 0;

  for (int i = 0; i < n; ++i) {
    meh += v[i];

    // Store maximum so far as well as starting and ending position
    // of the subsequence
    if (msf < meh) {
      msf = meh;
      start = s;
      end = i;
    }

    // If maximum ending here is negative, then it's definitely 
    // better to restart
    if (meh < 0) {
      meh = 0;
      s = i + 1;
    }
  }

  return msf;
}
