/**
 * Disjoint-set
 *
 * Complexity (Time): O(1)
 *   make_set  -> O(1)
 *   find_set  -> O(a(n))
 *   union_set -> O(a(n))
 * Complexity (Space): O(n)
 */

int h[MAX];
int par[MAX];
int size[MAX];

// Initialize element x
void make_set(int x) {
  par[x] = x;
  h[x] = 0;
  size[x] = 1;
}


// Return set index from element x
int find_set(int x) {
  if (par[x] != x)
    par[x] = find_set(par[x]);
  return par[x];
}


// Make x and y belong to the same set
void union_set(int x, int y) {
  x = find_set(x);
  y = find_set(y);

  if (x == y)
    return;

  if (h[x] > h[y])
    swap(x, y);

  par[x] = y;
  size[y] += size[x];

  if (h[x] == h[y])
    h[x]++;
}
